#include "jngen.h"
#include <iostream>
#include <cmath>
using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv);
    parseArgs(argc, argv);

    int n = getOpt(0);
    int type = getOpt(1);

    cout << n << endl;
    switch (type) {
        case 0:
            cout << Tree::random(n).shuffled().add1() << endl;
            break;
        case 1:
            cout << Tree::randomPrim(n).shuffled().add1() << endl;
            break;
        case 2:
            cout << Tree::randomPrim(n, -n).shuffled().add1() << endl;
            break;
        case 3:
            cout << Tree::randomPrim(n, n).shuffled().add1() << endl;
            break;
        case 4:
            cout << Tree::randomPrim(n, n / 2).shuffled().add1() << endl;
            break;
        case 5:
            cout << Tree::randomPrim(n, -n / 2).shuffled().add1() << endl;
            break;
        case 6:
            cout << Tree::randomKruskal(n).shuffled().add1() << endl;
            break;
        case 7:
            cout << Tree::bamboo(n).shuffled().add1() << endl;
            break;
        case 8:
            cout << Tree::star(n).shuffled().add1() << endl;
            break;
        case 9:
            cout << Tree::caterpillar(n, n / 2).shuffled().add1() << endl;
            break;
        case 10:
            cout << Tree::caterpillar(n, n / 10).shuffled().add1() << endl;
            break;
        case 11:
            cout << Tree::caterpillar(n, (int) sqrt(n)).shuffled().add1() << endl;
            break;
        case 12:
            cout << Tree::caterpillar(n, n - (int) sqrt(n)).shuffled().add1() << endl;
            break;
        case 13:
            cout << Tree::binary(n).shuffled().add1() << endl;
            break;
        case 14:
            cout << Tree::kary(n, 3).shuffled().add1() << endl;
            break;
        case 15:
            cout << Tree::kary(n, (int) sqrt(n)).shuffled().add1() << endl;
            break;
        default:
            exit(1);
    }

    return 0;
}
