#include "testlib.h"
#include <vector>

using namespace std;

void dfs(const vector<vector<int>>& gr, vector<bool>& used, int u) {
    used[u] = true;
    for (int v : gr[u]) {
        if (!used[v]) {
            dfs(gr, used, v);
        }
    }
}

int main(int argc, char* argv[]) {
    static constexpr int MAXN = 200'000;

    registerValidation(argc, argv);

    int n = inf.readInt(2, MAXN, "n");
    inf.readEoln();

    vector<vector<int>> gr(n);
    vector<bool> used(n);
    for (int i = 0; i < n - 1; ++i) {
        int u = inf.readInt(1, n, format("u[%d]", i + 1)) - 1;
        inf.readSpace();
        int v = inf.readInt(1, n, format("v[%d]", i + 1)) - 1;
        inf.readEoln();

        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    dfs(gr, used, 0);
    for (int i = 0; i < n; ++i) {
        ensuref(used[i], "%d-th vertex is not connected to the root", i + 1);
    }

    inf.readEof();

    return 0;
}
