#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

void dfs(const vector<vector<int>>& gr, vector<int>& par, int u, int p) {
    par[u] = p;
    for (int v : gr[u]) {
        if (v != p) {
            dfs(gr, par, v, u);
        }
    }
}

bool check(int n, const vector<int>& par, const vector<int>& friends, const vector<int>& leaves) {
    for (int l : leaves) {
        vector<int> pos = friends;
        bool ok = false;
        
        vector<int> path;
        int i = l;
        while (i != -1) {
            path.push_back(i);
            i = par[i];
        }
        reverse(path.begin(), path.end());

        int cur_pos = 0;
        while (path[cur_pos] != l) {
            for (int& x : pos) {
                if (x != -1) {
                    if (cur_pos + 1 < path.size() && path[cur_pos + 1] == x) {
                        ok = true;
                    }
                    x = par[x];
                }
            }
            ++cur_pos;
            for (int x : pos) {
                if (x == path[cur_pos]) {
                    ok = true;
                }
            }
        }

        if (!ok) {
            return false;
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    vector<int> leaves;
    for (int i = 1; i < n; ++i) {
        if (gr[i].size() == 1) {
            leaves.push_back(i);
        }
    }

    vector<int> par(n);
    dfs(gr, par, 0, -1);

    int res = n;
    for (int mask = 0; mask < 1 << leaves.size(); ++mask) {
        vector<int> l;
        for (int i = 0; i < leaves.size(); ++i) {
            if (mask & (1 << i)) {
                l.push_back(leaves[i]);
            }
        }
        if (check(n, par, l, leaves)) {
            res = min(res, (int) l.size());
        }
    }

    cout << res << endl;

    return 0;
}
