// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXN = 40;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(0, n * (n - 1) / 2, "m");
	inf.readEoln();

	set<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, n, format("a_%d", i + 1));
		inf.readSpace();
		int b = inf.readInt(1, n, format("b_%d", i + 1));
		inf.readEoln();
		ensuref(a != b, "a_%d shouldn't be equal to b_%d", i + 1, i + 1);
		if (a > b) {
			swap(a, b);
		}
		ensuref(!edges.count({a, b}), "all pairs should be different");
		edges.insert({a, b});
	}

	inf.readEof();

	return 0;
}