// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a] |= 1ll << b;
		graph[b] |= 1ll << a;
	}
	for (int i = 0; i < n - 1; ++i) {
		int j = i + 1;
		graph[i] ^= 1ll << j;
		graph[j] ^= 1ll << i;
	}

	int part1 = n / 2;
	int part2 = n - part1;
	ll part1_mask = (1ll << part1) - 1;
	vector<int> dp(1 << part2, INF);
	for (int mask = 0; mask < 1 << part1; ++mask) {
		bool ok = true;
		int need_part2 = 0;
		for (int i = 0; i < part1; ++i) {
			if (!(mask & (1 << i))) {
				if (graph[i] & part1_mask & ~mask) {
					ok = false;
					break;
				}
				need_part2 |= graph[i] >> part1;
			}
		}
		if (ok) {
			dp[need_part2] = min(dp[need_part2], __builtin_popcount(mask));
		}
	}

	int ans = INF;

	for (int mask = 0; mask < 1 << part2; ++mask) {
		bool ok = true;
		for (int i = 0; i < part2; ++i) {
			dp[mask | (1 << i)] = min(dp[mask | (1 << i)], dp[mask]);
		}

		for (int i = 0; i < part2; ++i) {
			if (!(mask & (1 << i))) {
				if ((graph[i + part1] >> part1) & ~mask) {
					ok = false;
					break;
				}
			}
		}

		if (ok) {
			ans = min(ans, dp[mask] + __builtin_popcount(mask));
		}
	}

	cout << ans * 2 << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}