// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
string dirs = "DRUL";

int ctoi(char c) {
	return find(dirs.begin(), dirs.end(), c) - dirs.begin();
}

const int MAX_STEPS = 100000;

int main(int argc, char* argv[]) {
	registerInteraction(argc, argv);

	int n = inf.readInt();
	int m = inf.readInt();
	int sx = inf.readInt() - 1;
	int sy = inf.readInt() - 1;
	
	string strategy = inf.readToken();
	int avoid_x = -1, avoid_y = -1;
	if (strategy == "avoid") {
		avoid_x = inf.readInt() - 1;
		avoid_y = inf.readInt() - 1;
	}
	deque<pii> snake;
	vector<vector<bool>> field(n, vector<bool>(m));
	snake.push_back({sx, sy});
	field[sx][sy] = true;
	pii apple = {-1, -1};

	auto gen_apple = [&]() {
		if (strategy == "random") {
			while (true) {
				int x = rnd.next(0, n - 1);
				int y = rnd.next(0, m - 1);
				if (!field[x][y]) {
					apple = {x, y};
					return;
				}
			}
		} else if (strategy == "nearest") {
			vector<pii> vars;
			int best = INF;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (!field[i][j]) {
						int val = abs(i - snake.front().ff) + abs(j - snake.front().ss);
						if (val < best) {
							best = val;
							vars.clear();
						}
						if (val == best) {
							vars.push_back({i, j});
						}
					}
				}
			}
			apple = vars[rnd.next(0, szof(vars) - 1)];
		} else if (strategy == "farest") {
			vector<pii> vars;
			int best = -INF;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (!field[i][j]) {
						int val = abs(i - snake.front().ff) + abs(j - snake.front().ss);
						if (val > best) {
							best = val;
							vars.clear();
						}
						if (val == best) {
							vars.push_back({i, j});
						}
					}
				}
			}
			apple = vars[rnd.next(0, szof(vars) - 1)];
		} else if (strategy == "avoid") {
			vector<pii> vars;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (!field[i][j] && pii(avoid_x, avoid_y) != pii(i, j)) {
						vars.push_back({i, j});
					}
				}
			}
			if (!szof(vars)) {
				vars.push_back({avoid_x, avoid_y});
			}
			apple = vars[rnd.next(0, szof(vars) - 1)];
		} else {
			assert(false);
		}
	};

	cout << n << " " << m << "\n" << sx + 1 << " " << sy + 1 << "\n";
	gen_apple();
	cout << apple.ff + 1 << " " << apple.ss + 1 << "\n";
	cout.flush();

	int cnt_steps = 0;

	while (true) {
		++cnt_steps;
		char dir = ouf.readLine("D|U|L|R")[0];
		int d = ctoi(dir);
		int nx = snake.front().ff + dx[d];
		int ny = snake.front().ss + dy[d];
		if (!(0 <= nx && nx < n && 0 <= ny && ny < m)) {
			cout << "fail\n";
			cout.flush();
			quitf(_wa, "went out of the field");
		}
		if (pii(nx, ny) == apple) {
			snake.push_front({nx, ny});
			field[nx][ny] = true;
			if (szof(snake) == n * m) {
				cout << "win\n";
				cout.flush();
				tout << cnt_steps << " steps" << endl;
				quitf(_ok, "%d steps", cnt_steps);
			}
			if (cnt_steps == MAX_STEPS) {
				cout << "fail\n";
				cout.flush();
				quitf(_wa, "didn't win in %d steps", MAX_STEPS);
			}
			gen_apple();
			cout << "new\n";
			cout << apple.ff + 1 << " " << apple.ss + 1 << "\n";
			cout.flush();
		} else {
			if (cnt_steps == MAX_STEPS) {
				cout << "fail\n";
				cout.flush();
				quitf(_wa, "didn't win in %d steps", MAX_STEPS);
			}
			field[snake.back().ff][snake.back().ss] = false;
			snake.pop_back();
			if (field[nx][ny]) {
				cout << "fail\n";
				cout.flush();
				quitf(_wa, "snake ate itself");
			}
			snake.push_front({nx, ny});
			field[nx][ny] = true;
			cout << "ok\n";
			cout.flush();
		}
	}
	

	return 0;
}