// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
string dirs = "DRUL";

int ctod(char c) {
	return find(dirs.begin(), dirs.end(), c) - dirs.begin();
}

char vtoi(int x, int y) {
	for (int i = 0; i < 4; ++i) {
		if (dx[i] == x && dy[i] == y) {
			return i;
		}
	}
	assert(false);
	return -1;
}

string move(char c) {
	// cerr << "move " << c << endl;
	cout << c << endl;
	string res;
	cin >> res;
	// cerr << res << endl;
	return res;
}

void solve() {
	int n, m;
	cin >> n >> m;
	int x, y;
	cin >> x >> y;
	--x; --y;
	int ax, ay;
	cin >> ax >> ay;
	--ax; --ay;

	// cerr << n << " " << m << "\n" << x + 1 << " " << y + 1 << "\n" << ax + 1 << " " << ay + 1 << "\n";

	vector<pii> cycle;
	if (n % 2 == 0) {
		for (int i = 0; i < n; ++i) {
			if (i % 2 == 0) {
				for (int j = 1; j < m; ++j) {
					cycle.push_back({i, j});
				}
			} else {
				for (int j = m - 1; j >= 1; --j) {
					cycle.push_back({i, j});
				}
			}
		}
		for (int i = n - 1; i >= 0; --i) {
			cycle.push_back({i, 0});
		}
	} else if (m % 2 == 0) {
		for (int j = 0; j < m; ++j) {
			if (j % 2 == 0) {
				for (int i = 1; i < n; ++i) {
					cycle.push_back({i, j});
				}
			} else {
				for (int i = n - 1; i >= 1; --i) {
					cycle.push_back({i, j});
				}
			}
		}
		for (int j = m - 1; j >= 0; --j) {
			cycle.push_back({0, j});
		}
	} else {
		for (int j = 0; j <= m - 3; ++j) {
			if (j % 2 == 0) {
				for (int i = n - 2; i >= 0; --i) {
					cycle.push_back({i, j});
				}
			} else {
				for (int i = 0; i <= n - 2; ++i) {
					cycle.push_back({i, j});
				}
			}
		}
		for (int i = 0; i <= n - 2; ++i) {
			if (i % 2 == 0) {
				cycle.push_back({i, m - 2});
				cycle.push_back({i, m - 1});
			} else {
				cycle.push_back({i, m - 1});
				cycle.push_back({i, m - 2});
			}
		}
		for (int j = m - 2; j >= 0; --j) {
			cycle.push_back({n - 1, j});
		}
 	}

 	// for (auto p : cycle) {
 	// 	cerr << p.ff << " " << p.ss << endl;
 	// }

 	int pos = find(cycle.begin(), cycle.end(), pii(x, y)) - cycle.begin();
	while (true) {
		if (n % 2 == 1 && m % 2 == 1 && ax == n - 1 && ay == m - 1 && x == n - 2 && y == m - 1) {
			string res = move('D');
			if (res == "win") {
				return;
			}
			assert(res == "new");
			cin >> ax >> ay;
			--ax; --ay;
			++x;
		} else if (n % 2 == 1 && m % 2 == 1 && x == n - 1 && y == m - 1) {
			string res = move('L');
			--y;
			if (res == "new") {
				cin >> ax >> ay;
				--ax; --ay;
			} else if (res == "win") {
				return;
			}
			pos = find(cycle.begin(), cycle.end(), pii(x, y)) - cycle.begin();
		} else {
			int npos = (pos + 1) % szof(cycle);
			int d = vtoi(cycle[npos].ff - cycle[pos].ff, cycle[npos].ss - cycle[pos].ss);
			string res = move(dirs[d]);
			if (res == "new") {
				cin >> ax >> ay;
				--ax; --ay;
			} else if (res == "win") {
				return;
			}
			tie(x, y) = cycle[npos];
			pos = npos;
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}