#include <fstream>
#include <algorithm>
using namespace std;
ifstream fin("all_rectangles.txt");
ofstream fout("ris.mp");
void draw_rectangle(int h1l, int h1u, int w1l, int w1r, int h2l, int h2u, int w2l, int w2r)
{
	fout << "\tfill (" << w1l << "u, -" << h1l << "u) -- (" << w1r << "u, -" << h1l << "u) -- (" << w1r << "u, -" << h1u << "u) -- (" << w1l << "u, -" << h1u << "u) -- cycle shifted p withcolor red;\n";
	fout << "\tfill (" << w2l << "u, -" << h2l << "u) -- (" << w2r << "u, -" << h2l << "u) -- (" << w2r << "u, -" << h2u << "u) -- (" << w2l << "u, -" << h2u << "u) -- cycle shifted p withcolor green;\n";
	fout << "\tdraw ((0, 0) -- (0, -h * u) -- (w * u, -h * u) -- (w * u, 0) -- cycle) shifted p withpen pencircle scaled 2;\n";
	fout << "\tdraw ((0, 0) -- (0, -h * u) -- (w * u, -h * u) -- (w * u, 0) -- cycle) shifted p withpen pencircle scaled 2;\n";
	fout << "\tfor i := 1 upto h - 1:\n";
	fout << "\t\tdraw ((0, -i * u) -- (w * u, -i * u)) shifted p;\n";
	fout << "\tendfor;\n";
	fout << "\tfor i := 1 upto w - 1:\n";
	fout << "\t\tdraw ((i * u, 0) -- (i * u, -h * u)) shifted p;\n";
	fout << "\tendfor;\n";
}
int main()
{
	int n;
	fin >> n;
	int H, W;
	fin >> H >> W;

	fout << "beginfig(1);\n";
	fout << "\tu := .8cm;\n";
	fout << "\tpair p;\n";
	fout << "\tnumeric h, w;\n";
	fout << "\th = " << H << ";\n";
	fout << "\tw = " << W << ";\n";

	const int columns = 5;
	const int rows = (n + columns - 1) / columns;
	for (int i = 0; i < rows; ++i)
		for (int j = 0; j < min(columns, n - i * columns); ++j)
		{
			fout << "\t\n";
			fout << "\tp := (" << j * (1 + W) << "u, -" << i * (1 + H) + H << "u);\n";
			int h1l, h1u, w1l, w1r, h2l, h2u, w2l, w2r;
			fin >> h1l >> h1u >> w1l >> w1r >> h2l >> h2u >> w2l >> w2r;
			draw_rectangle(h1l, h1u, w1l, w1r, h2l, h2u, w2l, w2r);
		}
	fout << "endfig;\n";
	fout << "bye\n";
}