#include <iostream>
using namespace std;
typedef long long ll;
const int M = 1000000007;
int prod(const int x, const int y)
{
	return ((ll)x) * y % M;
}
int sum(const int x, const int y)
{
	int z = x + y;
	if (z >= M)
		z -= M;
	return z;
}
int dif(const int x, const int y)
{
	int z = x - y;
	if (z < 0)
		z += M;
	return z;
}
int inv(const int x, const int m = M)
{
	return (x == 1 ? 1 : (1 - inv(m % x, x) * ((ll)m)) / x + m);
}
struct residue
{
	int x;
	residue(int x = 0) : x(x)
	{
	}
	residue operator+(residue r) const
	{
		return residue(sum(x, r.x));
	}
	residue operator-(residue r) const
	{
		return residue(dif(x, r.x));
	}
	residue operator*(residue r) const
	{
		return residue(prod(x, r.x));
	}
	residue rinv() const
	{
		return residue(inv(x));
	}
	residue operator/(residue r) const
	{
		return *this * r.rinv();
	}
	int value() const
	{
		return x;
	}
};
int inter(const int H, const int h)
{
	if (2 * h <= H - 4)
	{
		int hh = prod(h, h);
		return prod(hh, dif(prod(H, h), prod(dif(dif(prod(11, hh), prod(6, h)), 5), inv(12))));
	}
	else
	{
		residue rH = H;
		residue rh = h;
		return ((rh * rh * rh * rh * 5
			+ (rH - 1) * rH * (rH + 1) * (rH + 2)
			- rh * rh * rh * (rH * 2 + 1) * 10
			- rh * (rH * 2 + 1) * (rH * rH + rH - 1) * 4
			+ rh * rh * (rH * (rH + 1) * 24 + 1)) / 12).value();
	}
}
int all(const int H, const int h)
{
	return prod(prod(sum(dif(prod(2, H), h), 1), h), inv(2));
}
int main()
{
	int H, W, h, w;
	cin >> H >> W >> h >> w;
	int all_one = prod(all(H, h), all(W, w));
	cout << dif(prod(all_one, all_one), prod(inter(H, h), inter(W, w))) << '\n';
}