
def little_intersecting_case(H: int, h:int) -> int:
	return h * h * H * h - h * h * (11 * h * h - 6 * h - 5) // 12


def big_intersecting_case(H:int, h:int) -> int:
	return (h * h * h * h * 5
		 + (H - 1) * H * (H + 1) * (H + 2)
		 - h * h * h * (H * 2 + 1) * 10
		 - h * (H * 2 + 1) * (H * H + H - 1) * 4
		 + h * h * (H * (H + 1) * 24 + 1)) // 12


def intersecting_cases_extended(H: int, h:int, little:bool) -> int:
	if little:
		return little_intersecting_case(H, h)
	else:
		return big_intersecting_case(H, h)


def is_little_case(H: int, h:int) -> bool:
	return 2 * h <= H


def intersecting_cases(H: int, h:int) -> int:
	return intersecting_cases_extended(H, h, is_little_case(H, h))


def all_cases_one_rectangle(H: int, h:int) -> int:
	return (2 * H - h + 1) * h // 2


def all_cases(H: int, h:int) -> int:
	return all_cases_one_rectangle(H, h) ** 2


M = 1000000007
H, W = map(int, input().split())
h, w = map(int, input().split())
first = is_little_case(H, h)
second = is_little_case(W, w)
print((all_cases(H, h) * all_cases(W, w) - intersecting_cases_extended(H, h, first) * intersecting_cases_extended(W, w, first)) % M)