// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

long double calc_diff(double x, double y) {
	return abs(x - y) / max(abs(x), 1.0);
}

const long double eps = 1e-6;

bool is_ok(double x, double y) {
	return calc_diff(x, y) <= eps;
}

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	long double real_ab = inf.readDouble();
	long double real_ac = inf.readDouble();
	long double real_bc = inf.readDouble();

	long double a = ouf.readDouble();
	long double b = ouf.readDouble();
	long double c = ouf.readDouble();

	ouf.ensuref(a > 0 && b > 0 && c > 0, "all numbers should be positive");

	long double p_ab = sqrt(a * b);
	long double p_ac = sqrt(a * c);
	long double p_bc = sqrt(b * c);

	ouf.ensuref(is_ok(real_ab, p_ab), "g(a, b) = %lf differs from needed value (%lf) too much (%lf)", (double) p_ab, (double) real_ab, (double) calc_diff(real_ab, p_ab));
	ouf.ensuref(is_ok(real_ac, p_ac), "g(a, c) = %lf differs from needed value (%lf) too much (%lf)", (double) p_ac, (double) real_ac, (double) calc_diff(real_ac, p_ac));
	ouf.ensuref(is_ok(real_bc, p_bc), "g(b, c) = %lf differs from needed value (%lf) too much (%lf)", (double) p_bc, (double) real_bc, (double) calc_diff(real_bc, p_bc));

	quitf(_ok, "values are correct, a = %lf, b = %lf, c = %lf", (double) a, (double) b, (double) c);

	return 0;
}