#include "testlib.h"
#include <vector>
#include <unordered_set>

using namespace std;

struct __message {
    unsigned int no;
    unsigned int from;
    unsigned int to;

    __message(unsigned int no, unsigned int from, unsigned int to) : no(no), from(from), to(to) {}
};

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int t = atoi(argv[1]), p = atoi(argv[2]), q = atoi(argv[3]), qq = atoi(argv[4]);
    int n = t + p + 1;
    println(n, q);

    vector<int> roles(n);
    for (int i = 1; i < n; i++) {
        roles[i] = (i <= t ? 1 : 2);
    }
    shuffle(roles.begin(), roles.end());
    println(roles.begin(), roles.end());

    vector<int> teachers;
    int director = 0;
    for (int i = 0; i < n; i++) {
        if (roles[i] == 0) {
            director = i;
        } else if (roles[i] == 1) {
            teachers.push_back(i);
        }
    }

    unordered_set<unsigned int> teachers_common;
    vector<unordered_set<unsigned int>> unread(n);
    vector<__message> messages;
    unordered_set<unsigned int> all_unread;

    for (unsigned int i = 0; i < q; i++) {
        unsigned int cmd = 0;
        if (rnd.next(q + i) < qq + i) {
            cmd = 3;
        } else {
            cmd = rnd.next(q) < i && !all_unread.empty() ? 2 : 1;
        }

        if (cmd == 1) {
            unsigned int a = rnd.next(n);
            unsigned int b = rnd.next(n - 1);
            if (b >= a) {
                b += 1;
            }
            println(1, a + 1, b + 1);
            all_unread.insert(messages.size());
            messages.push_back(__message(i, a, b));

            if (roles[a] == 0) {
                unread[b].insert(i);
            } else if (roles[a] == 1) {
                unread[b].insert(i);
                if (roles[b] == 2) {
                    unread[director].insert(i);
                    all_unread.insert(messages.size());
                    messages.push_back(__message(i, a, director));
                }
            } else {
                if (roles[b] == 1) {
                    teachers_common.insert(i);
                    unread[director].insert(i);
                    all_unread.insert(messages.size());
                    messages.push_back(__message(i, a, director));
                } else {
                    unread[b].insert(i);
                }
            }
        } else if (cmd == 2) {
            unsigned int j = *all_unread.begin();
            all_unread.erase(all_unread.begin());
            auto msg = messages[j];

            unsigned int a = msg.to, x = msg.no;
            if (roles[a] == 1 && teachers_common.count(x) > 0) {
                teachers_common.erase(x);
                a = teachers[rnd.next(teachers.size())];
            } else {
                unread[a].erase(x);
            }

            println(2, a + 1, x + 1);
        } else {
            unsigned int a = rnd.next(n);
            unsigned int retries = 0;
            while (retries < 10 && unread[a].empty() && (roles[a] != 1 || teachers_common.empty())) {
                a = rnd.next(n);
                retries++;
            }
            println(3, a + 1);
        }
    }
}