#include <vector>
#include <unordered_set>
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    unsigned int n = inf.readInt(1, 200000, "n");
    inf.readSpace();
    unsigned int q = inf.readInt(1, 200000, "q");
    inf.readEoln();

    std::vector<unsigned int> roles(n);
    int director = -1;
    for (unsigned int i = 0; i < n; i++) {
        if (i > 0) {
            inf.readSpace();
        }
        roles[i] = inf.readInt(0, 2, "r_i");
        if (roles[i] == 0) {
            ensuref(director == -1, "There should be only one director");
            director = i;
        }
    }
    ensuref(director > -1, "There should be a director");
    inf.readEoln();

    std::unordered_set<unsigned int> teachers_common;
    std::vector<std::unordered_set<unsigned int>> unread(n);

    for (unsigned int i = 0; i < q; i++) {
        unsigned int cmd = inf.readInt(1, 3, "t_i");
        inf.readSpace();
        unsigned int a = inf.readInt(1, n, "a_i") - 1;

        if (cmd == 1) {
            inf.readSpace();
            unsigned int b = inf.readInt(1, n, "b_i") - 1;
            
            ensuref(a != b, "people should be different");

            if (roles[a] == 0) {
                unread[b].insert(i);
            } else if (roles[a] == 1) {
                unread[b].insert(i);
                if (roles[b] == 2) {
                    unread[director].insert(i);
                }
            } else {
                if (roles[b] == 1) {
                    teachers_common.insert(i);
                    unread[director].insert(i);
                } else {
                    unread[b].insert(i);
                }
            }
        } else if (cmd == 2) {
            inf.readSpace();
            unsigned int x = inf.readInt(1, q, "x_i") - 1;

            if (roles[a] == 1 && teachers_common.count(x) > 0) {
                teachers_common.erase(x);
            } else {
                ensuref(unread[a].count(x) > 0, "Expected %d to have a message %d", a, x);
                unread[a].erase(x);
            }
        }
        inf.readEoln();
    }

    inf.readEof();

}