// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> type;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		type.push_back(t);
	}

	vector<int> cnt(n);
	int add_teachers = 0, add_head = 0;
	vector<int> message_type;
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		message_type.push_back(-1);
		if (t == 1) {
			int a, b;
			cin >> a >> b;
			--a; --b;
			if (type[a] == 2 && type[b] == 1) {
				message_type.back() = 1;
				++add_teachers; ++add_head;
			} else if (type[a] == 1 && type[b] == 2) {
				++add_head;
				++cnt[b];
			} else {
				++cnt[b];
			}
		} else if (t == 2) {
			int a, x;
			cin >> a >> x;
			--a; --x;
			if (type[a] == 1 && message_type[x] == 1) {
				--add_teachers;
			} else if (type[a] == 0 && message_type[x] == 1) {
				--add_head;
				--add_teachers;
			} else {
				--cnt[a];
			}
		} else {
			int a;
			cin >> a;
			--a;
			int ans = cnt[a];
			if (type[a] == 0) {
				ans += add_head;
			}
			if (type[a] == 1) {
				ans += add_teachers;
			}

			cout << ans << "\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}