#include "testlib.h"
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int total_time;
int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, 1000, "n");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        string a = inf.readLine("[0-9][0-9]:[0-9][0-9]", "a_i");
        ensuref(a.size() == 5 && a[2] == ':', "incorrect input format");
        int mins = (a[0] - '0') * 10 + (a[1] - '0');
        int secs = (a[3] - '0') * 10 + (a[4] - '0');
        int song_time = mins * 60 + secs;
        total_time += song_time;
        ensuref(mins >= 0 && mins < 60, "song duration should be between 0 and 59 minutes inclusive");
        ensuref(secs >= 0 && secs < 60, "song duration should be between 0 and 59 seconds inclusive");
        ensuref(mins * 60 + secs > 0 && mins * 60 + secs < 60 * 60, "song duration should bebigger than 0 and less than an hour");
        // inf.readEoln();
    }
    ensuref(total_time < 24 * 60 * 60, "total song duration should be less than a day");
    inf.readEof();
    return 0;
}
